//
//  ComAgilentLibintunemsalModule.swift
//  LibIntuneMSAL
//
//  Created by Your Name
//  Copyright (c) 2019 Your Company. All rights reserved.
//

import UIKit
import TitaniumKit
import MSAL


/**
 
 Titanium Swift Module Requirements
 ---
 
 1. Use the @objc annotation to expose your class to Objective-C (used by the Titanium core)
 2. Use the @objc annotation to expose your method to Objective-C as well.
 3. Method arguments always have the "[Any]" type, specifying a various number of arguments.
 Unwrap them like you would do in Swift, e.g. "guard let arguments = arguments, let message = arguments.first"
 4. You can use any public Titanium API like before, e.g. TiUtils. Remember the type safety of Swift, like Int vs Int32
 and NSString vs. String.
 
 */

@objc(ComAgilentLibintunemsalModule)
class ComAgilentLibintunemsalModule: TiModule {

  public let testProperty: String = "Hello World"
  let fusionURL = "xxxx"
  let peopleURL = "xxxx"
    
    //let kScopes: [String] = ["https://graph.microsoft.com/user.read"]
    let kFusionScope: [String] =  ["xxxxx"]
    let kScopes: [String] = ["ssss"]
    
    let kClientID = "423232323"
    let kAuthority = "https://login.microsoftonline.com/common" // directory id
    
    var accessToken = String()
    var applicationContext : MSALPublicClientApplication?
    var webViewParamaters : MSALWebviewParameters?

  func moduleGUID() -> String {
    return "5b6b2533-19a2-4cb9-be3f-6ce77b053713"
  }
  
  override func moduleId() -> String! {
    return "com.agilent.libintunemsal"
  }

  override func startup() {
    super.startup()
    debugPrint("[DEBUG] \(self) loaded")
  }

  @objc(example:)
  func example(arguments: Array<Any>?) -> String? {
    guard let arguments = arguments, let params = arguments[0] as? [String: Any] else { return nil }

    // Example method. 
    // Call with "MyModule.example({ hello: 'world' })"
    debugPrint("[DEBUG] \(params["hello"] ?? "Test") loaded")
    return params["hello"] as? String
  }

  
  @objc public var exampleProp: String {
     get { 
        // Example property getter
        return "Titanium rocks!"
     }
     set {
        // Example property setter
        // Call with "MyModule.exampleProp = 'newValue'"
        self.replaceValue(newValue, forKey: "exampleProp", notification: false)
     }
   }
    
    
    @objc(createMSALObj:)
    func createMSALObj (unused: Any?) -> ComAgilentLibintunemsalProxy {
         debugPrint("print from module createMSALObj")
        return ComAgilentLibintunemsalProxy()
    }
    
    @objc(testFromAppc:)
    func testFromAppc(unused: Any?) {
        print("printing from module testFromAppc")
        debugPrint("[DEBUG] print from module test from appc")
    }
    
    @objc(testArray:)
    func testArray(param:Array<Any>?) -> String {
         guard let param = param, let message = param.first else { return "No arguments" }
        NSLog("testArray")
        debugPrint("testArray debugPrint")
        return "from swift return\(message)"
    }
    
    
    @objc(initiateMSALTokenRequest:)
        func initiateMSALTokenRequest(requestParam: Array<Any>?) -> Any? {
        return "initiateMSALTokenRequest"
          /*  debugPrint("[DEBUG] \(String(describing: requestParam ?? nil)) loaded")
            NSLog("Test ------");
            print(requestParam!)
        
        
            guard let arguments = requestParam, let params = arguments[0] as? [String: Any] else { return nil }
            var checkString = "First"
            do {
                
                _ = requestParam!
            guard let authorityURL = URL(string: kAuthority) else {
                //self.updateLogging(text: "Unable to create authority URL")
                debugPrint("Unable to create authority URL")
                return "Unable to create authority URL"
            }
            
            let authority = try MSALAADAuthority(url: authorityURL)
            debugPrint("Initiate MSAL token request #2")
                checkString = "Second"
            let msalConfiguration = MSALPublicClientApplicationConfig(clientId: kClientID, redirectUri: nil, authority: authority)
            self.applicationContext = try MSALPublicClientApplication(configuration: msalConfiguration)
            debugPrint("Initiate MSAL token request #3")
                checkString = "Thrd"
                self.webViewParamaters = MSALWebviewParameters(parentViewController: params["VC"] as! TiViewController)
                //TODO: this need to provided the view controller object detail
                checkString = "four"
                debugPrint("Initiate MSAL token request #4")
                guard let currentAccount = self.currentAccount() else {
                           // We check to see if we have a current logged in account.
                           // If we don't, then we need to sign someone in.
                    debugPrint("Initiate MSAL token request #5")
                           acquireTokenInteractively()
                           return "Initiate MSAL token request #5"
                       }
                checkString = "Five"
                    debugPrint("Initiate MSAL token request #6")
                       acquireTokenSilently(currentAccount)
                
            }
            catch _ as NSError {
             debugPrint("Error while initlaite the Token Request")
                checkString = "Six"
            }
            return checkStringv*/
        }
        
    //    func initWebViewParams() {
    //           self.webViewParamaters = MSALWebviewParameters(parentViewController: requestParamDict.object(forKey: "VC") as! TiViewController)
    //
    //        //TODO: this need to provided the view controller object detail
    //    }
        
        //@objc(acquireTokenInteractively:)
        func acquireTokenInteractively() {
            debugPrint("acquireTokenInteractively request #1")
            guard let applicationContext = self.applicationContext else { return }
            guard let webViewParameters = self.webViewParamaters else { return }

            let parameters = MSALInteractiveTokenParameters(scopes: kScopes, webviewParameters: webViewParameters)
            parameters.promptType = .selectAccount;
            debugPrint("acquireTokenInteractively request #2")
            applicationContext.acquireToken(with: parameters) { (result, error) in
                
                if error != nil {
                    debugPrint("Could not acquire token: ")
                    return
                }
                
                guard let result = result else {
                    
                    debugPrint("Could not acquire token: No result returned")
                    return
                }
                
                self.accessToken = result.accessToken
                debugPrint("Access Token %@", self.accessToken)
                //self.updateSignOutButton(enabled: true)
            }
        }
        
        //@objc(acquireTokenSilently:)
        func acquireTokenSilently(_ account : MSALAccount!) {
                debugPrint("acquireTokenSilently request #1")
                guard let applicationContext = self.applicationContext else { return }
                
                /**
                 
                 Acquire a token for an existing account silently
                 
                 - forScopes:           Permissions you want included in the access token received
                 in the result in the completionBlock. Not all scopes are
                 guaranteed to be included in the access token returned.
                 - account:             An account object that we retrieved from the application object before that the
                 authentication flow will be locked down to.
                 - completionBlock:     The completion block that will be called when the authentication
                 flow completes, or encounters an error.
                 */
                
                let parameters = MSALSilentTokenParameters(scopes: kScopes, account: account)
                
                applicationContext.acquireTokenSilent(with: parameters) { (result, error) in
                    
                    debugPrint("acquireTokenSilently request #2")
                    
                    if let error = error {
                        
                        let nsError = error as NSError
                        
                        // interactionRequired means we need to ask the user to sign-in. This usually happens
                        // when the user's Refresh Token is expired or if the user has changed their password
                        // among other possible reasons.
                        
                        if (nsError.domain == MSALErrorDomain) {
                            
                            if (nsError.code == MSALError.interactionRequired.rawValue) {
                                
                                DispatchQueue.main.async {
                                    self.acquireTokenInteractively()
                                }
                                return
                            }
                        }
                        
    //                    self.updateLogging(text: "Could not acquire token silently: \(error)")
                        debugPrint("Could not acquire token silently")
                        return
                    }
                    
                    guard let result = result else {
                        
                        debugPrint("Could not acquire token: No result returned")
                        return
                    }
                    
                    self.accessToken = result.accessToken
                    debugPrint("Refresh Access token is %@", self.accessToken)
                    //self.updateSignOutButton(enabled: true)
                    
                    //self.callHanaWS();
        //
                }
            }
        
        func currentAccount() -> MSALAccount? {
            debugPrint("currentAccount request #1")
            guard let applicationContext = self.applicationContext else { return nil }
            
            // We retrieve our current account by getting the first account from cache
            // In multi-account applications, account should be retrieved by home account identifier or username instead
            do {
                debugPrint("currentAccount request #2")
                let cachedAccounts = try applicationContext.allAccounts()
                
                if !cachedAccounts.isEmpty {
                    return cachedAccounts.first
                }
                
            } catch let error as NSError {
                
                debugPrint("Didn't find any accounts in cache: %@", error)
            }
            
            return nil
        }

    
}
